Subject: RE: X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has characters from languages other than the system locale

From: "George Trakatelis" <[email-masked]>
Date: Thu, 6 Nov 2014 20:16:40 +0200

Dear Dmitry,

Setting Russian as the default language for non-Unicode programs showed that

x2goclient-4.0.3.0-20141021-setup.exe behaves correctly with test user name
фисвуа. 

[To change system locale, I followed the instructions in 
http://windows.microsoft.com/en-us/windows/change-system-locale#1TC=windows-
7]

So please investigate for other causes for the misbehavior of x2goclient's
current release on your system.
One such a cause would be known_hosts being read-only. 

[@Mike#2: ssh_write_knownhost()'s return value should have been checked 
whether it's zero or SSH_ERROR and acted upon]

As there are portions of x2goclient that depend on code that ignores system
locale [such as getenv( "USERNAME" )], 
you'd be better off if you didn't use user names with non-Ascii characters
for the time being. 

George

> -----Original Message-----
> From: George Trakatelis [mailto:[email-masked]]
> Sent: Thursday, November 6, 2014 6:44 PM
> To: [email-masked]'
> Cc: 'Mike Gabriel'; 'Mike DePaulo'; 'Dmitry E. Mikhailov'
> Subject: RE: X2Go Client for Windows cannot create
> C:\Users\<username>\ssh\known_hosts file when the username has
> characters from languages other than the system locale
> 
> I just noticed that Dmitry replied only to me, so I copy his reply
> below:
> 
> ==========================================================
> It's the #566
> No-go if OS locale is Russian & path to `known_hosts' contains
> Russian/Cyrillic characters.
> OK if if OS locale is Russian & path to `known_hosts' contains only
> English characters.
> Frankly, I don't know if generic English/Latin characters belong to
> Russian/Cyrillic character set.
> Best regards,
> 	Dmitry Mikhailov.
> ==========================================================
> 
> Afaik, the patch is applied to both the preview (pre01) and the current
> release (20141021) of X2Go Client for Windows 4.0.3.0, so it's rather
> unusual to observe different behavior from preview to release.
> In my system (Greek Windows 8.1) with a user name in Cyrillic (фисвуа)
> (fyi, I pressed a-b-c-d-e-f to get it) and Greek locale both versions
> exhibited the same erroneous behavior (that's why Mike#2 introduced bug
> #611).
> 
> I'll try to set Russian as the main language of my system to see what
> happens (if I can find my way in Russian and succeed in getting back to
> Greek :)
> 
> George
> 
> > -----Original Message-----
> > From: Dmitry E. Mikhailov [mailto:[email-masked]]
> > Sent: Thursday, November 6, 2014 1:45 PM
> > To: George Trakatelis
> > Subject: Re: X2Go Client for Windows cannot create
> > C:\Users\<username>\ssh\known_hosts file when the username has
> > characters from languages other than the system locale
> >
> > On 11/06/2014 04:37 PM, George Trakatelis wrote:
> > > Hi all,
> > >
> > > I remind you that bug #566
> > > 'X2Go Client for Windows cannot create
> > > C:\Users\<username>\ssh\known_hosts
> > > file when the username has non-English characters'
> > > was cloned to bug #611
> > > 'X2Go Client for Windows cannot create
> > > C:\Users\<username>\ssh\known_hosts
> > > file when the username has characters from languages other than the
> > > system locale'
> > > in an effort to find a global solution utilizing UTF-8 encoding.
> > > Imho, bug #611 cannot be resolved in the near future.
> > >
> > > I must ask Dmitry to re-state what his problem is.
> > > Is it an issue related to
> > >
> > > a. bug #566 as described above,
> > It's the #566
> >
> > No-go if OS locale is Russian & path to `known_hosts' contains
> > Russian/Cyrillic characters.
> >
> > OK if if OS locale is Russian & path to `known_hosts' contains only
> > English characters.
> >
> > Frankly, I don't know if generic English/Latin characters belong to
> > Russian/Cyrillic character set.
> >
> > Best regards,
> > 	Dmitry Mikhailov.